﻿using System;
using System.IO;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Parsing;
using Syncfusion.SfPdfViewer.XForms;
using Xamarin.Forms;

namespace SyncFusionPdf
{
    public partial class MainPage : ContentPage
	{
		private byte[] data;

		public MainPageModel Model => (MainPageModel)BindingContext;

		public MainPage()
        {
            InitializeComponent();

            BindingContext = new MainPageModel();

            PdfViewer.DocumentSaveInitiated += OnDocumentSaveInitiated;
        }

        private void OnDocumentSaveInitiated(object sender, DocumentSaveInitiatedEventArgs e)
        {
            if (e == null)
                throw new ArgumentNullException(nameof(e));

			if (e.SaveStream.CanSeek)
				e.SaveStream.Seek(0, SeekOrigin.Begin);

			data = ((MemoryStream)e.SaveStream).ToArray();

			Model.IsFlattenEnabled = true;
		}

        private void OnSaveClicked(object sender, EventArgs e)
        {
			PdfLoadedDocument loadedDoc = new PdfLoadedDocument(data);

			loadedDoc.Form.Flatten = true;

			string folder = Path.Combine(App.Folder, "pim_mobile");
			string fileName = $"Test_{DateTime.Now:dd_MM_yyyy_HH_mm_ss}.pdf";
			string filePath = Path.Combine(folder, fileName);

			using (Stream stream = File.OpenWrite(filePath))
			{
				loadedDoc.Save(stream);

				stream.Flush();
			}
        }

   //     private void OnSaveClicked(object sender, EventArgs e)
   //     {
			//PdfDocument doc = new PdfDocument();

			//PdfLoadedDocument loadedDoc = new PdfLoadedDocument(data);

			////loadedDoc.Form.Flatten = true;
			//PdfDocumentBase.Merge(doc, loadedDoc);

			//string folder = Path.Combine(App.Folder, "pim_mobile");
			//string fileName = $"Test_{DateTime.Now:dd_MM_yyyy_HH_mm_ss}.pdf";
			//string filePath = Path.Combine(folder, fileName);

			//using (Stream stream = File.OpenWrite(filePath))
			//{
			//	doc.Form.Flatten = true;
			//	doc.Save(stream);

			//	stream.Flush();
			//}
   //     }
    }
}