﻿using System.ComponentModel;
using System.IO;
using System.Runtime.CompilerServices;

namespace SyncFusionPdf
{
    public class MainPageModel: INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        private Stream pdfStream;
        public Stream PdfStream
        {
            get
            {
                return pdfStream;
            }
            set
            {
				if (!ReferenceEquals(pdfStream, value))
				{
					pdfStream = value;

					OnPropertyChanged(nameof(PdfStream));
				}
            }
        }

        private bool isFlattenEnabled;
        public bool IsFlattenEnabled
        {
            get
            {
                return isFlattenEnabled;
            }
            set
            {
				if (isFlattenEnabled != value)
				{
					isFlattenEnabled = value;

					OnPropertyChanged(nameof(IsFlattenEnabled));
				}
            }
        }

        public MainPageModel()
		{
			string folder = Path.Combine(App.Folder, "pim_mobile");
			const string name = "Test_17_10_2019_11_57_55.pdf";

			string file = Path.Combine(folder, name);

            //PdfStream = new MemoryStream(Properties.Resources.PdfDatei);
            PdfStream = new MemoryStream(File.ReadAllBytes(file));
        }

        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}